<template>
  <q-table
    flat
    ref="tableRef"
    title="Equipo que participa del evento"
    :dense="true"
    :rows="dataSet"
    :columns="columnas"
    :rows-per-page-options="[0]"
    hide-bottom
    row-key="uuid"
    :loading="loading"
  >
    <!--------------------------------------
            loading
    ---------------------------------------->
    <template v-slot:loading>
      <Loading showing />
    </template>

    <template v-slot:no-data>Sin Equipo de adulto definido</template>
    <template v-slot:top-right>
      <div class="q-pa-sm">
        <q-btn-group outline class="q-gutter-sm">
          <q-btn
            color="blue"
            icon="group_add"
            flat
            label="Agregar Integrante"
            @click="modal = true"
          />
        </q-btn-group>
      </div>
    </template>

    <template v-slot:body-cell-datos="props">
      <q-td :props="props">
        <PersonaDetalle :persona="props.row.persona"></PersonaDetalle>
      </q-td>
    </template>

    <template v-slot:body-cell-opciones="props">
      <q-td :props="props">
        <div class="q-pa-md q-gutter-sm">
          <!-- Migrarlo a un componente, que acepte el objeto persona o el uuid , si recibe persona muesta un tooltip con algo de info basica -->
          <q-btn
            color="red"
            size="sm"
            square
            icon="person_remove"
            @click.prevent="equipoDel(props.row.uuid)"
          >
            <q-tooltip>
              Quitar del evento a {{ props.row.persona.apellidoynombre }}
            </q-tooltip>
          </q-btn>
        </div>
      </q-td>
    </template>
  </q-table>

  <q-dialog v-model="modal">
    <q-card style="width: 700px">
      <q-card-section>
        <div class="text-h6">Busqueda de Persona</div>
      </q-card-section>

      <q-card-section class="q-pt-none">
        <InputBuscar v-model="form.persona_uuid" />
      </q-card-section>

      <q-card-actions align="right">
        <q-btn
          flat
          label="Agregar"
          color="primary"
          v-close-popup
          @click.prevent="equipoAdd"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref, reactive } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import { useEventosInscriptosStore } from 'src/stores/eventos/inscriptos';
import { useRoute } from 'vue-router';
import PersonaDetalle from 'components/Personas/Detalle.vue';
import InputBuscar from 'components/Personas/InputBuscar.vue';
import Loading from 'src/components/Loading.vue';

// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'datos', label: 'Datos', field: 'datos', align: 'left' },
  { name: 'opciones', label: 'Opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  name: 'ListadoEquipoPartial',
  components: {
    Loading,
    PersonaDetalle,
    InputBuscar,
  },
  setup() {
    const tableRef = ref();

    const loading = ref(true);
    const modal = ref(false);
    const EventoInscriptosStore = useEventosInscriptosStore();
    const route = useRoute();
    const uuid = String(route.params.uuid);
    const form = reactive({
      evento_uuid: uuid,
      persona_uuid: '',
    });

    /*********************************************
     *  Metoto onRequest
     *  encargado de obtener los datos desde la API
     */
    const dataSet = ref([]);
    onMounted(() => {
      obtenerEquipo();
    });

    function obtenerEquipo() {
      loading.value = true;
      api
        .get('/api/eventos/equipo/' + uuid, { params: { rowsPerPage: 999 } })
        .then((response: AxiosResponse) => {
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function equipoAdd() {
      loading.value = true;
      api
        .post('/api/eventos/equipo', form)
        .then(() => {
          obtenerEquipo();
        })
        .finally(() => {
          loading.value = false;
        });
    }
    function equipoDel(uuid: string) {
      loading.value = true;
      api
        .delete('/api/eventos/equipo', { params: { uuid } })
        .then(() => {
          obtenerEquipo();
        })
        .finally(() => {
          loading.value = false;
        });
    }

    return {
      tableRef,
      columnas,
      dataSet,
      EventoInscriptosStore,
      equipoAdd,
      equipoDel,
      loading,
      modal,
      form,
    };
  },
});
</script>
